; DeBug 12 bit
;   Help   USART 
;   bcf    TRISC,6      ; Make RC6 an output
;   movlw  19h          ; 9600 baud @4MHz
   movlw  0x01          ; / baud @ 48 MHz  
   movwf  SPBRG,ACCESS	; 	

   bsf    TXSTA,TXEN,ACCESS   ; Enable transmit
   bsf    TXSTA,BRGH,ACCESS   ; Select high baud rate
	bsf    BAUDCTL,BRG16,ACCESS; Select 16    baud rate
;  400-500    50 
   
   bsf    RCSTA,SPEN,ACCESS   ; Enable Serial Port
   bsf    RCSTA,CREN,ACCESS   ; Enable continuous reception

;	Extern	Table_Sinus
		PCPWM_Page	; BSR for PCPWM Task
	movlf	0x3A,DeBug_BufLcd+9,BANKED;    9    .
	movlf	0x0,PCPWM_MK1+0,BANKED; .     12 	 
	movlf	0x14,PCPWM_MK1+1,BANKED; .     12 	 


	clrf	PCPWM_AmpSin+0,BANKED	;      V/F  
	clrf	PCPWM_AmpSin+1,BANKED	; 
	
	bra		DeBugLoopAmp
;   0x0D   0x0A    -   
;   .
HexNibSend
	andlw	0x0F					;    
	addlw	0x30					;
	cpfsgt	DeBug_BufLcd+9,BANKED;   9 > WREG	
	addlw	0x7				;     
ByteSend
	movwf	TXREG,ACCESS			;
	nop	;     USART
;	btfss	PIR1,TXIF,ACCESS	;    USART
	btfss	TXSTA,TRMT,ACCESS	;    
	bra		$-2					;
		return
SendHexWord	macro	ArgA,Adr1,Lit1
	movlw	Lit1	;     
	rcall	ByteSend	; 

	swapf	ArgA+1,W,Adr1	;   - 
	rcall	HexNibSend	;   

	movf	ArgA+1,W,Adr1	;
	rcall	HexNibSend	;   

	swapf	ArgA+0,W,Adr1	;
	rcall	HexNibSend	;  

	movf	ArgA+0,W,Adr1	;
	rcall	HexNibSend	;  

 endm

DeBugLoopAmp:

	clrf	DeBug_BufLcd+0,BANKED	;  
	clrf	DeBug_BufLcd+1,BANKED	; 12   

;	movlw	0x0D	;     
;	rcall	ByteSend	; 
	movlw	0x0A	;     
	rcall	ByteSend	; 

 SendHexWord	PCPWM_AmpSin+0,BANKED,"%"	; =====0====== PCPWM_AmpSin+0,BANKED	;      V/F  

DeBugLoop:

	movlw	";";0x0D	;     
	rcall	ByteSend	; 
	movlw	0x0A	;     
	rcall	ByteSend	; 

PDC_16L	equ	PDC0L ;   

	BSF EECON1, EEPGD,ACCESS	; Point to PROGRAM memory

NotSendSinus	;   2  

	Inc16	DeBug_BufLcd+0,BANKED	;   
	movf	DeBug_BufLcd+1,W,BANKED	; 12   
	andlw	0xF0					;    
		bz	$+6
	goto EndDeBugLoop			; 

	movf	DeBug_BufLcd+1,W,BANKED	; 12   
	andlw	0x0F					;    
	movwf	DeBug_BufLcd+1,BANKED	;   
	movwf	TBLPTRH,ACCESS			;  
	movff	DeBug_BufLcd+0,TBLPTRL	;

	btfss	TBLPTRL,0,ACCESS	;   -   
		bra		NotSendSinus

	bcf		TBLPTRL,0,ACCESS	;   -   

 SendHexWord	DeBug_BufLcd+0,BANKED,"#";=====1======   
	
	Add16L	TBLPTRL,ACCESS,Table_Sinus	;     

;1)   :
 tblrd*+	;       
	movf	TABLAT,W,ACCESS	;   16  
	movwf	SynMulBuf+7,BANKED;  -   

 				movwf	DeBug_BufLcd+6,BANKED; ********  LCD

 mulwf	PCPWM_AmpSin+0,BANKED;      V/F  
	movff16	PRODL,SynMulBuf+0	;  

 tblrd*+	;    
	movf	TABLAT,W,ACCESS	;   16  

 				movwf	DeBug_BufLcd+7,BANKED; ********  LCD

 SendHexWord	DeBug_BufLcd+6,BANKED,"=" ;=====2======    
 movf	TABLAT,W,ACCESS	; ******  *********   16  

;2)   :
 mulwf	PCPWM_AmpSin+1,BANKED;      <0x10
	movff16	PRODL,SynMulBuf+2	;     
;  4    -    .

;3)  Sin   Amp,    
 mulwf	PCPWM_AmpSin+0,BANKED;      V/F  

; ArgB,A1B,ArgA,A1A	;   -  ;   B=B+A 
  Add16	SynMulBuf+1,BANKED,PRODL,ACCESS;    

;========
 clrf	WREG,ACCESS;	; ADD16 Macro	;     
 addwfc	SynMulBuf+3,F,BANKED			;  - 24    
;========
		 
;4)  Sin   Amp,    
	movf	SynMulBuf+7,W,BANKED;  Sin 
 mulwf	PCPWM_AmpSin+1,BANKED;     

; ArgB,A1B,ArgA,A1A	;   -  ;   B=B+A 
  Add16	SynMulBuf+1,BANKED,PRODL,ACCESS;    

;========
 clrf	WREG,ACCESS;	; ADD16 Macro	;     
 addwfc	SynMulBuf+3,F,BANKED			;  - 24    
;========

	btfss	TABLAT,7,ACCESS	;    16  
		bra	ExitMul
;Sub16 ArgB,A1B,ArgA,A1A ;   -  ;  B=B-A 
  Sub16	SynMulBuf+2,BANKED,PCPWM_AmpSin+0,BANKED;     FXM1616S


ExitMul
;          8 355 585/0x7f7f01  -8 355 585/0x8080FF

#ifdef __DEBUG;*******   
	movf	SynMulBuf+0,W,BANKED;     
	movf	SynMulBuf+1,W,BANKED;  0  
	movf	SynMulBuf+2,W,BANKED;  1  
	movf	SynMulBuf+3,W,BANKED;    = 0  
 #endif
 
;     -       
;       0  2048  PDC, ,  = 0 = 1024 PDC.
;0=0=0000=00000000==  
;64=90=7fff=007f7f01= ,   FEFE02,   - 7F7
;128=180=0000=00000000=  ,   FEFE02
;192=270=8001=ff8080ff= =  = 00000000000
;255=359=fcdc=fffcdf24= ,   = 7c5e25 -   
	movlw	0x01;	;  32     0x7f7f01
	ADDWF	SynMulBuf+0,F,BANKED; 
	movlw	0x7F;	;  32     0x7f7f01
	ADDWFC	SynMulBuf+1,F,BANKED; -1
	movlw	0x7F;	;  32     0x7f7f01
	ADDWFC	SynMulBuf+2,F,BANKED; -2
; bnc	OvrLoad	;    , 
;		Beeper_Toggle
; OvrLoad

;	CLRF	WREG,ACCESS;	;     =0
;	ADDWFC	SynMulBuf+3,F,BANKED; 

 SendHexWord	SynMulBuf+1,BANKED,"*" ; =====3======   *   

;	movff16	SynMulBuf+0,PCPWM_SMB+0;	:4	;      BANK0
;	movff16	SynMulBuf+2,PCPWM_SMB+2;	:4	;      BANK0

;         -    .
; 12   * 12   = 24 ,   ,   16 .
; 16          ,    .
;       0.
;  16     11-12   -    16 , 
;  32    11-12  
;    1/10     
	movlw	low(0xFFFF/0xA);,W	,A1A	;   10%  0xFFFF/ = 0x1999 
	subwf	SynMulBuf+1,F,BANKED		;    ,  : =B-A

	movlw	high(0xFFFF/0xA);,W,A1A		;  , 10%  0xFFFF
;	btfss	_C		;     
;	incfsz	ArgA+1,W,A1A	;      1,
	subwfb	SynMulBuf+2,F,BANKED	;     -   
		bnc	ZeroPoint	;  -  
;    1/5       
	movlw	low(0xFFFF-0xFFFF/0x5);,W	,A1A	;   10%  0xFFFF/5=0x3333
;	movlw	0x2D;,W	,A1A	;   10%  0xFFFF/5=0x3333

	subwf	SynMulBuf+1,W,BANKED		;      

	movlw	high(0xFFFF-0xFFFF/0x5);,W,A1A		;  , 10%  0xFFFF
;	movlw	0x33;,W,A1A		;  , 10%  0xFFFF
	subwfb	SynMulBuf+2,W,BANKED	;     -   
		bc	MaxPoint	;   -  

 SendHexWord	SynMulBuf+1,BANKED,"+" ; =====4======   *   

;     ,         11  
; PCPWM_MK1+0   \Init_PCPWM_3F.inc:217
 ;FXM1616U2 macro D_Arg,A1D,A_Arg,A1A,B_Arg,A1B,_Work,A1W; ;    -  
  FXM1616U2	SynMulBuf+4,	bnk,	SynMulBuf+1,	bnk,	PCPWM_MK1+0,	bnk,	SynMulBuf+0,	bnk;	  
; FXM1680U	SynMulBuf+4,	bnk,	SynMulBuf+1,	bnk,	PCPWM_MK1+0,	bnk;,	SynMulBuf+0,	bnk;	  
;	FXM1680U C_Arg,BANKED	,A_Arg,BANKED	,B_Arg,BANKED;,	Math_Work+3,BANKED	;


	movff	SynMulBuf+6,PDC_16L		;  
	movff	SynMulBuf+7,PDC_16L-1	;  
		bra		Done
;OvrLoad
;OverLoad	;
;	Beeper_Toggle
;	goto	InitAll	;

MaxPoint:; 12  PWM -      .
; 05/01/2019      
;    PDC=4*PTPer-DTCon -    DT -  
;      ~ 0.1 .

; 
;PcPwmPdcMax	:2;F,BANKED;  PDC   -  
 movf	PcPwmPdcMax+0,W,BANKED	;       
 subwf	DTCON,W,ACCESS			;   
 movwf	PDC_16L,ACCESS			; .  
 movf	PcPwmPdcMax+1,W,BANKED	; _  
 btfsc	_C						;
 decf	WREG,ACCESS				;  
 movwf	PDC_16L-1,ACCESS		; .  

;	movlf	0xF0,PDC_16L,ACCESS		; .  
;	movlf	0xF,PDC_16L-1,ACCESS	; .  

		bra		Done
ZeroPoint:	;   =0,      
;     PDC -    DTCON -    
;    DT.
;    PDC=DTCon -    DT -  
;      ~ 0.1 .
; *****       DT - ***  ***  .*****
;    -         DT.
;
; 	movlf	0x18,DTCON,ACCESS	;  1     48/2  
;	clrf	PDC_16L,ACCESS		;;  
 movlf	0x19,PDC_16L,ACCESS	;  
	clrf	PDC_16L-1,ACCESS	;;  
Done:
	movff	PDC_16L,DeBug_BufLcd+4		;  
	movff	PDC_16L-1,DeBug_BufLcd+5	;  

 SendHexWord	DeBug_BufLcd+4,BANKED,"$";=====5======   PDC

 goto	DeBugLoop	
; 	SinTabLdDbg	 Angle_1+2,PDC0L	;      

EndDeBugLoop

;	Inc16	PCPWM_AmpSin+0,BANKED	; ;    
	Add16L	PCPWM_AmpSin+0,BANKED,0xD ;    

	movf	PCPWM_AmpSin+1,W,BANKED	;  
	andlw	0xF0					;    
		bnz	$+6
 	goto	DeBugLoopAmp	

	nop
	nop
	halt
	sleep
	bra $-2
