	LIST
; ,   PSW.
#define _C		STATUS,C,ACCESS
#define _Z		STATUS,Z,ACCESS
#define _OV		STATUS,OV,ACCESS

LSB			equ	0 ; Less Significant Bit
MSB			equ	7 ; Most Significant Bit
acs	equ	ACCESS	;  
bnk	equ	BANKED	;   
	NOLIST
De_Bug_Pc	macro;		ArgA,ArgB
	;movff	PCL,Pc_Debug		;  
	;movff	PCL+1,Pc_Debug+1	; 
	;movff	STKPTR,Stack_Debug	; 
	endm

Add32		macro		ArgB,A1B,ArgA,A1A ;    -  
				;   B=B+A 
	movf	ArgA,W	,A1A	;  
	addwf	ArgB,F,A1B	; 	;  + ,   =B+A

	movf	ArgA+1,W,A1A	;  
	;btfsc	_C		;     
	;incfsz	WREG,W,A1A	;      1,
	addwfc	ArgB+1,F,A1B	;     -   

	movf	ArgA+2,W,A1A	;  
	;btfsc	_C		;     
	;incfsz	WREG,W,A1A	;      1,
	addwfc	ArgB+2,F,A1B	;     -   

	movf	ArgA+3,W,A1A	;  
	;btfsc	_C		;     
	;incfsz	WREG,W,A1A	;      1,
	addwfc	ArgB+3,F,A1B	;     -   

	endm

Add24		macro		ArgB,A1B,ArgA,A1A ;    -  
				;   B=B+A 
	movf	ArgA,W	,A1A	;  
	addwf	ArgB,F,A1B	; 	;  + ,   =B+A

	movf	ArgA+1,W,A1A	;  
	;btfsc	_C		;     
	;incfsz	WREG,W,A1A	;      1,
	addwfc	ArgB+1,F,A1B	;     -   

	movf	ArgA+2,W,A1A	;  
	;btfsc	_C		;     
	;incfsz	WREG,W,A1A	;      1,
	addwfc	ArgB+2,F,A1B	;     -   

	endm

Add24L		macro		ArgB,A1B,ArgA ;    -  
				;   B=B+A 
;	movf	ArgA,W	,A1A	;  
	movlw	low(ArgA)		;
	addwf	ArgB,F,A1B	; 	;  + ,   =B+A

;	movf	ArgA+1,W,A1A	;  

 errorlevel  -311 ; 	Message[311]  
	movlw	high(ArgA)		;
 errorlevel  +311 ;  Message[311] 

	;btfsc	_C		;     
	;incfsz	WREG,W,A1A	;      1,
	addwfc	ArgB+1,F,A1B	;     -   

;	movf	ArgA+2,W,A1A	;  
	movlw	upper(ArgA)		;
	;btfsc	_C		;     
	;incfsz	WREG,W,A1A	;      1,
	addwfc	ArgB+2,F,A1B	;     -   

	endm

Add24L3		macro		ArgD,A1D,ArgB,A1B,ArgA ;    -  
;   D=B+A  3   ,      

;	movf	ArgA+0,W	,A1A;  
	movlw	low(ArgA)		; W=A(0)
	addwf	ArgB+0,W,A1B	; W=B+A
	movwf	ArgD+0,A1D	 	; D=W

;	movf	ArgA+1,W	,A1A;  
 errorlevel  -311 ; 	Message[311]
	movlw	high(ArgA)		; W=A(1)
 errorlevel  +311 ;  Message[311] 
	addwfc	ArgB+1,W,A1B	; W=B+A+C
	movwf	ArgD+1,A1D	; 	; D=B+A

;	movf	ArgA+2,W,A1A	;  
	movlw	upper(ArgA)		; W=A(2)
	addwfc	ArgB+2,W,A1B	; W=B+A+C
	movwf	ArgD+2,A1D	; 	; D=B+A
 endm

Add24S3		macro		ArgD,A1D,ArgB,A1B,ArgA,A1A, ;    -  
;   D=B+A  3   ,      
;       -     

	movf	ArgA+0,W	,A1A;  
;	movlw	low(ArgA)		; W=A(0)
	addwf	ArgB+0,W,A1B	; W=B+A
;	movwf	ArgD+0,A1D	 	; D=W	;      

	movf	ArgA+1,W	,A1A;  
; errorlevel  -311 ; 	Message[311]
;	movlw	high(ArgA)		; W=A(1)
; errorlevel  +311 ;  Message[311] 
	addwfc	ArgB+1,W,A1B	; W=B+A+C
	movwf	ArgD+1,A1D	; 	; D=B+A

	movf	ArgA+2,W,A1A	;  
;	movlw	upper(ArgA)		; W=A(2)
	addwfc	ArgB+2,W,A1B	; W=B+A+C
	movwf	ArgD+2,A1D	; 	; D=B+A
 endm


Sub24		macro		ArgB,A1B,ArgA,A1A 	;    -  
				;   B=B-A 
	movf	ArgA,W,A1A	;  
	subwf	ArgB,F,A1B	;    ,  : =B-A

	movf	ArgA+1,W,A1A	; - 
;	btfss	_C		;     
;	incfsz	ArgA+1,W,A1A	;  -    1,
	subwfb	ArgB+1,F,A1B	;     -   

	movf	ArgA+2,W,A1A	;  
;	btfss	_C		;     
;	incfsz	ArgA+2,W,A1A	;      1,
	subwfb	ArgB+2,F,A1B	;     -   
	endm


Inc16	macro	ArgA,A1A ;    -  
	infsnz	ArgA,F,A1A		; 
	incf	ArgA+1,F,A1A	; 
	endm
Neg16	macro	ArgA,A1A ;    -  
;      1 =   
	comf	ArgA,F,A1A		; 
	comf	ArgA+1,F,A1A	; 

	infsnz	ArgA,F,A1A		; 
	incf	ArgA+1,F,A1A	; 
	endm


Inc24		macro	ArgA,A1A ;    -  
 local Exit
	incfsz	ArgA,F,A1A	; 
		bra		Exit
	incfsz	ArgA+1,F,A1A	; 
		bra		Exit
	incfsz	ArgA+1,F,A1A	; 
		bra		Exit
Exit:
	endm

Add16		macro		ArgB,A1B,ArgA,A1A ;    -  
	movf	ArgA,W	,A1A	;  
	addwf	ArgB,F,A1B	; 	;  + ,   =B+A

	movf	ArgA+1,W,A1A	;  
;		btfsc	_C		;     						;  
;		incfsz	WREG,W,A1A	;      1,	;  
;	addwf	ArgB+1,F,A1B	;     -   	;  
	addwfc	ArgB+1,F,A1B	;     -   
	endm

Add16L		macro		ArgB,A1B,Lit16;    -  
	movlw	LOW(Lit16)	;  
	addwf	ArgB,F,A1B	; 	;  + ,   =B+A

	movlw	HIGH(Lit16)	;  
;		btfsc	_C		;     						;  
;		incfsz	WREG,W,A1A	;      1,	;  
;	addwf	ArgB+1,F,A1B	;     -   	;  
	addwfc	ArgB+1,F,A1B	;     -   
	endm


Sub		macro		ArgB,A1B,ArgA,A1A 	;    -  
	;   B=B-A       .
	movf	ArgA,W	,A1A	;  
	subwf	ArgB,F,A1B		;    ,  : =B-A
	endm

Sub16		macro		ArgB,A1B,ArgA,A1A 	;    -  
						;   B=B-A 
	movf	ArgA,W	,A1A	;  
	subwf	ArgB,F,A1B		;    ,  : =B-A

	movf	ArgA+1,W,A1A	;  
;	btfss	_C		;     
;	incfsz	ArgA+1,W,A1A	;      1,
	subwfb	ArgB+1,F,A1B	;     -   
	endm


Sub16L		macro		ArgB,A1B,Lit16 	;    -  
						;   B=B-A 
	movlw	LOW(Lit16)	;  
	subwf	ArgB,F,A1B		;    ,  : =B-A

	movlw	HIGH(Lit16)	;  
;	btfss	_C		;     
;	incfsz	WREG,W,A1A	;      1,
	subwfb	ArgB+0x1,F,A1B	;     -   

	endm


movff16	macro		ArgA,ArgB
	movff	ArgA,ArgB		;  
	movff	ArgA+1,ArgB+1	; 
	endm
movff24	macro		ArgA,ArgB
	movff	ArgA,ArgB		;  
	movff	ArgA+1,ArgB+1	; 
	movff	ArgA+2,ArgB+2	; 
	endm

movff_N	macro		ArgA,ArgB,NumMoves
	local a = 0
    while a < NumMoves
	movff	ArgA+a,ArgB+a
a += 1
    endw
	endm

clrf_N	macro		ArgA,Adr1,NumClears
	local a = 0
    while a < NumClears
	clrf	ArgA+a,Adr1
a += 1
    endw
	endm

setf_N	macro		ArgA,Adr1,NumClears
	local a = 0
    while a < NumClears
	setf	ArgA+a,Adr1
a += 1
    endw
	endm


;     04/08/2006
movb    MACRO Port2,bit2,A2,Port1,bit1,A1
	btfss Port2,bit2,A2	; move Port2,bit2
	bcf Port1,bit1,A1	; into Port1,bit1
	btfsc Port2,bit2,A2	;
	bsf Port1,bit1,A1	;
	ENDM
;     04/08/2006
movbi   MACRO Port2,bit2,A2,Port1,bit1,A1
	btfss Port2,bit2,A2	; move INVERTED Port2,bit2
	bsf Port1,bit1,A1		; into Port1,bit1
	btfsc Port2,bit2,A2	;
	bcf Port1,bit1,A1	;
	ENDM

movlf	MACRO Literal8,File8,Adr1;  8  Literal8
	movlw	Literal8	;    7  
	movwf	File8,Adr1	;   File7
	ENDM			;   WREG

;	NOLIST
UASRT_Rx_Prep	macro	;  / 
	movff	Usart_SPBRGH,SPBRGH	; H byte SPBRG
	movff	Usart_SPBRG,SPBRG	; L byte SPBRG

	incf	Usart_LCD_Count,F,ACCESS
	lfsr	1,Usart_Rx_Buf				; 
	movlf	Usart_Rx_Max,Usart_Rx_Count,ACCESS	;  
	endm
GoToWreg16	macro	NumShiftWreg,TempBuff,Adr1 ;  Tmp 6 
;     -   WREG
;     
;       W  
;         
;  25  ,   , .
;  :
;	movf	Int_T5_Route,W,ACCESS	;
;	bz		T_R0 ; 
;	dcfsnz	WREG,W,ACCESS	
;	bra		T_R1 ; =,  2,   
;	dcfsnz	WREG,W,ACCESS	
;	bra		T_R2 ;  ,  3,   
;	dcfsnz	WREG,W,ACCESS	
;	bra		T_R3 ;  , 
;   2   ,  .

; 20/03/2017  16   24.


 local BeginJumpBlock
	movwf	TempBuff+3,Adr1			;     PC
	clrf	TempBuff+4,Adr1			; 
;	clrf	TempBuff+5,Adr1			; 
 #if	NumShiftWreg>0
	bcf		_C				;   
	rlcf	TempBuff+3,F,Adr1		;      
	rlcf	TempBuff+4,F,Adr1		;      
;	rlcf	TempBuff+5,F,Adr1		;      
 #endif
 #if	NumShiftWreg>1
	bcf		_C				;   
	rlcf	TempBuff+3,F,Adr1		;      
	rlcf	TempBuff+4,F,Adr1		;      
;	rlcf	TempBuff+5,F,Adr1		;      
 #endif
 #if	NumShiftWreg>2
	bcf		_C				;   
	rlcf	TempBuff+3,F,Adr1		;      
	rlcf	TempBuff+4,F,Adr1		;      
;	rlcf	TempBuff+5,F,Adr1		;      
 #endif

	movlf	Low(BeginJumpBlock),TempBuff,Adr1	;  
	movlf	High(BeginJumpBlock),TempBuff+1,Adr1	;  
;	movlf	Upper(BeginJumpBlock),TempBuff+2,Adr1	;  
	
	Add16	TempBuff,Adr1,TempBuff+3,Adr1	;   16    
	movff	TempBuff+1,PCLATH	;
	;movff	TempBuff+2,PCLATU	;
	clrf	PCLATU,ACCESS		;
	movf	TempBuff,W,Adr1		;
	movwf	PCL,0 ;  PCLAT
	;addwf	PCL,F,0	; -- PCL.  U  H     
BeginJumpBlock
	endm
GoToWreg	macro	NumShiftWreg,TempBuff,Adr1 ;  Tmp 1 
;     -   WREG
;     
; 20/03/2017   , 16     
;  10   1 
;      CASE    - .

 local BeginJumpBlock;,Continue,Continue1	;
	movwf	TempBuff,Adr1;PCLATU,ACCESS	;  
	;movwf	PCLATU,ACCESS	;   - ,   

	movlf	High(BeginJumpBlock),PCLATH,ACCESS	;	 
	;movf	PCLATU,W,ACCESS	;    
	;clrf	PCLATU,ACCESS		;  -  =0,    
 	bcf		_C				;   

	rlcf	TempBuff,W,Adr1	;      

	addlw	Low(BeginJumpBlock)	;   ,
	btfsc	_C	;     ?
		incf	PCLATH,F,ACCESS		;  1   

	clrf	PCLATU,ACCESS		;  -  =0
 	movwf	PCL,ACCESS ;  PCLAT
BeginJumpBlock
	endm

BraReg	macro	RegPoint,Adr1 ;    -  
;  -  
; 20/03/2017   , 16  
;     -   
;     
; 8-9  
 local BeginJumpBlock;,Continue,Continue1	;
 movlf	High(BeginJumpBlock),PCLATH,ACCESS	;	 
 bcf		_C				;   
 rlcf	RegPoint,W,Adr1	;      
 addlw	Low(BeginJumpBlock)	;   ,
 btfsc	_C	;     ?
	incf	PCLATH,F,ACCESS		;  1   
	clrf	PCLATU,ACCESS		;  -  =0
 movwf	PCL,ACCESS ;  PCLAT
BeginJumpBlock
	endm
;      6  :
; 45   0058    0E00         MOVLW 0                                
; 46   005A    6EFA         MOVWF PCLATH, ACCESS                   
; 47   005C    5001         MOVF 0x1, W, ACCESS                    
; 48   005E    90D8         BCF STATUS, 0, ACCESS                  
; 49   0060    36E8         RLCF WREG, F, ACCESS                   
; 50   0062    26F9         ADDWF PCL, F, ACCESS     
;   PCLATU       ADDWF PCL, F, ACCESS
;    PCLATH     (      )
;      ADDWF PCL, F, ACCESS   
;           256   .
FXD3216U macro A_Arg,A1A,B_Arg,A1B,_Work,A1W; ;    -  
;  4  -    + 
;    _Work+0:+1
;  2  -   
;   4    = 0xFF
;  4    _Work,A1W
;Unsigned Division  32bit / 16bit -> 16bit + 16bit
;EXTWRD / LUK -> WRD, remainder -> EXT
;detailed EXT_H:EXT_L:WRD_H:WRD_L / LUK_H:LUK_L -> WRD_H:WRD_L
;On overflow or divide by zero: FFFFh -> WRD, FFFFh -> EXT
;LUK value remains. Affected registers: temp reg  Math_Work+0,BANKED,
; Math_Work+1,BANKED, Math_Work+2,BANKED, Math_Work+3,BANKED
 local D32_Loop,D32_3,D32_4,D32_NextShift,D32_OverFlow,D32_End;
; Step_0; ; DIV32: AN617 Page 13 FlowChart Comments
 clrf   _Work+0,A1W	; TEMP 24 
 clrf   _Work+1,A1W	; Clear Reminder
 clrf   _Work+2,A1W	; Partial Quotient= ;  
					; = Dividend	; 
 movlw  0xE0;-32;    ;LOOPS	;;i=0 ;   
;   = -32.     - .
;      . 
 movwf  _Work+3,A1W		;

;     -     
; 	incf	Math_Step,F,BANKED	;   ""     

; retlw	0x0
D32_Loop; SHIFT R8R6R4<<1; :
;   ///   
 bcf    _C		;   
 rlcf   A_Arg+0,f,A1A	; Left Shift	;   
 rlcf   A_Arg+1,f,A1A	; reminder		;   
 rlcf   A_Arg+2,f,A1A	; and			;  
 rlcf   A_Arg+3,f,A1A	; quotient		; 
 rlcf   _Work+0,f,A1W	;    
 rlcf   _Work+1,f,A1W	;      
 rlcf   _Work+2,f,A1W	;     
;update _Work+1,2=_Work+1,2-LUK if remains positive
 movf   B_Arg+0,w,A1B	; Substract Divisor	;  
;  
 subwf  _Work+0,F,A1W	; from partial		;     
 movf   B_Arg+1,w,A1B	; Reminder			;  
 subwfb _Work+1,W,A1W	;
   	bc     D32_4    ;borrow = !carry ; Result >0 ? ;  >0 ?
 ;16 bit subtraction < 0 ;      2     1 ?
;      "restore partial quotient" ?
;      c   WREG 
; (     ),      ?
;  20/03/2020 -   .
 tstfsz _Work+2,A1W		; - 
   	bra    D32_3    ;borrow from _Work+2
 ;24 bit subtraction < 0
 ;restore _Work+0 (_Work+1 is already unhanged)
 movf   B_Arg+0,w,A1B		;  
 addwf  _Work+0,F,A1W	;  
   	bra    D32_NextShift	;   , LSB=0  () 
        ;
D32_3
 decf   _Work+2,F,A1W	;update _Work+2  
D32_4
 movwf  _Work+1,A1W		;update _Work+0 (_Work+2 is already updated)
 		bsf    A_Arg+0,LSB,A1A    ; LSB=1
;  4     0 
;         ? 
 btfss  _Work+3,4,A1W	;>=16 counts remaining?
   	bra    D32_OverFlow    ;overflow
        ;
        ;next loop
D32_NextShift
	incfsz _Work+3,f,A1W	;
      	bra    D32_Loop		;
	bra		D32_End			;
;	incfsz Math_Work+3,f,BANKED
;		retlw	0x0	;    
        ;
    ;ready, result ok
;     _Work+0   
;    movff  _Work+0,A_Arg+2	;remainder
;    movff  _Work+1,A_Arg+3	;    

;D32_Return
;  movff	FXD3216U_Return,Math_Step;	
;    retlw	0x0	;    
        ;
        ;overflow
D32_OverFlow ;movlw  0FFh
        setf  A_Arg+0,A1A	;  
        setf  A_Arg+1,A1A	; 
        setf  _Work+0,A1W	;  
        setf  _Work+1,A1W	; 
		bsf		_C			;  /
;	bra  D32_Return
D32_End

	endm

FXM1616U macro A_Arg,A1A,B_Arg,A1B,_Work,A1W; ;    -  
;   A=A*B  ;  16*16  ,    
;  1      
; MULW: ;Multiplication 16bit * 16bit -> 32bit
;detailed:
; A_Arg+1:A_Arg+0 * B_Arg+1:B_Arg+0 -> A_Arg+3:A_Arg+2:A_Arg+1:A_Arg+0
;   B_Arg value remains.     Affected registers: 1 byte temp reg 
;  29 ,     
;     
;  FXM1616U A_Arg, BANKED,B_Arg,BANKED,Math_Work+3,BANKED 

 movf    A_Arg+1,w,A1A	;  
 mulwf   B_Arg+1,A1B	; B_Arg+1 * A_Arg+1
 movff   PRODH,A_Arg+3	; ,  
 movff   PRODL,A_Arg+2	;   

 movf    A_Arg+0,w,A1A	;  
 mulwf   B_Arg+0,A1B	; B_Arg+0 * A_Arg+0
 movff   PRODH,_Work	; ,  
 movff   PRODL,A_Arg+0	;   ,
;         

 mulwf   B_Arg+1,A1B	; B_Arg+1 * A_Arg+0
 movf    PRODL,w,ACCESS	;   , 
 addwf   _Work,f,A1W	; Add cross
 movf    PRODH,w,ACCESS	; products
 addwfc  A_Arg+2,f,A1A	;       1 
 clrf    WREG,ACCESS	;   
 addwfc  A_Arg+3,f,A1A	;

 movf    A_Arg+1,w,A1A	;
 mulwf   B_Arg+0,A1B	; B_Arg+0 * A_Arg+1
 movf    PRODL,w,ACCESS ;   , 
 addwf   _Work,w,A1W	;Add cross
 movwf   A_Arg+1,A1A	;
 movf    PRODH,w,ACCESS ; products
 addwfc  A_Arg+2,f,A1A	;       1 
 clrf    WREG,ACCESS	;   
 addwfc  A_Arg+3,f,A1A	;
 
	endm

FXM1616U2 macro D_Arg,A1D,A_Arg,A1A,B_Arg,A1B,_Work,A1W; ;    -  
;         106 "   "
;   D=A*B  ;  16*16  ,
; A     
;        4 .
;  1      
; MULW: ;Multiplication 16bit * 16bit -> 32bit
;detailed:
; A_Arg+1:A_Arg+0 * B_Arg+1:B_Arg+0 -> A_Arg+3:A_Arg+2:A_Arg+1:A_Arg+0
;   B_Arg value remains.     Affected registers: 1 byte temp reg 
;  29 ,     

 movf    A_Arg+1,w,A1A	;  
 mulwf   B_Arg+1,A1B	; B_Arg+1 * A_Arg+1
 movff   PRODH,D_Arg+3	; ,  
 movff   PRODL,D_Arg+2	;   

 movf    A_Arg+0,w,A1A	;  
 mulwf   B_Arg+0,A1B	; B_Arg+0 * A_Arg+0
 movff   PRODH,_Work	; ,  
 movff   PRODL,D_Arg+0	;   ,
;         
; A_Arg+0 in WREG unchanged
 mulwf   B_Arg+1,A1B	; B_Arg+1 * A_Arg+0
 movf    PRODL,w,ACCESS	;   , 
 addwf   _Work,f,A1W	; Add cross
 movf    PRODH,w,ACCESS	; products
 addwfc  D_Arg+2,f,A1D	;       1 
 clrf    WREG,ACCESS	;   
 addwfc  D_Arg+3,f,A1D	;

 movf    A_Arg+1,w,A1A	;      
 mulwf   B_Arg+0,A1B	; B_Arg+0 * A_Arg+1
 movf    PRODL,w,ACCESS ;   , 
 addwf   _Work,w,A1W	;Add cross
 movwf   D_Arg+1,A1D	;
 movf    PRODH,w,ACCESS ; products
 addwfc  D_Arg+2,f,A1D	;       1 
 clrf    WREG,ACCESS	;   
 addwfc  D_Arg+3,f,A1D	;
 
	endm

FXM0808SL	macro ArgB,A1B,Lit8	;      
 movlw Lit8	; 		MOVF	__AARGB0,W
 mulwf	ArgB,A1B
 btfsc	ArgB,MSB,A1B
	subwf	PRODH,F,ACCESS
 	endm
		
FXM1680U macro D_Arg,A1D,A_Arg,A1A,B_Arg,A1B;,_Work,A1W; ;    -  

;   D=A*B  ;  16*(8+0)  , A     ,     =0
;    16   32     1      
;        4 .
;    1      
; MULW: ;Multiplication 16bit * 8+0bit -> 32bit
;detailed:
; A_Arg+1:A_Arg+0 * B_Arg+1:B_Arg+0 -> A_Arg+3:A_Arg+2:A_Arg+1:A_Arg+0
;   B_Arg value remains.
;  29-12 ,     


 movf    A_Arg+1,w,A1A	;  
 mulwf   B_Arg+1,A1B	; B_Arg+1 * A_Arg+1
 movff   PRODH,D_Arg+3	; ,  
 movff   PRODL,D_Arg+2	;   

 movf    A_Arg+0,w,A1A	;   -  
 ;mulwf   B_Arg+0,A1B	; B_Arg+0 * A_Arg+0 =0
 ;movff   PRODH,_Work	; ,  =0
 clrf	D_Arg+0,A1D;movff   PRODL,D_Arg+0	;   , =0
 
;         
	; A_Arg+0 in WREG unchanged
 mulwf   B_Arg+1,A1B	; B_Arg+1 * A_Arg+0

 ;movf    PRODL,w,ACCESS	;   , 
 ;addwf   _Work,f,A1W	; Add cross
 ;movff	PRODL,_Work -   

 movf    PRODH,w,ACCESS	; products
 addwf  D_Arg+2,f,A1D	;       1 

 clrf    WREG,ACCESS	;   
 addwfc  D_Arg+3,f,A1D	;

 ;movf    A_Arg+1,w,A1A	;      
 ;mulwf   B_Arg+0,A1B	; B_Arg+0 * A_Arg+1	=0
 ;movf    PRODL,w,ACCESS ;   , 	=0
 ;movf	_Work,w,A1W;addwf   _Work,w,A1W	;Add cross _C=0
 movwf   D_Arg+1,A1D	;
 movf    PRODH,w,ACCESS ; products
 addwf  D_Arg+2,f,A1D	;       1 
 clrf    WREG,ACCESS	;   
 addwfc  D_Arg+3,f,A1D	;
 
	endm

FXM1680U2 macro D_Arg,A1D,A_Arg,A1A,B_Arg,A1B;,_Work,A1W; ;    -  

;B_Arg+0=0,   2  
;  PRODL:PRODH 

 movf    A_Arg+0,w,A1A	;     
 	mulwf   B_Arg+1,A1B	; B_Arg+1 * A_Arg+0
 movff   PRODH,D_Arg+0	;    

 movf    A_Arg+1,w,A1A	;  
 	mulwf   B_Arg+1,A1B	; B_Arg+1 * A_Arg+1

;     16    
 movf    D_Arg+0,w,A1D	;   
 addwf  PRODL,f,ACCESS	;       1 
 clrf    WREG,ACCESS	;   
 addwfc  PRODH,f,ACCESS	;
	endm


Tab16Load	macro	A_Arg,TableAdr;    16 
	movff	A_Arg,TBLPTRL	;  
	clrf	TBLPTRH,ACCESS		;  
	rlcf	TBLPTRL,F,ACCESS	;   
	rlcf	TBLPTRH,F,ACCESS	;    
	bcf		TBLPTRL,0,ACCESS	;    
	clrf	TBLPTRU,ACCESS		;   

;    - 24   - ,     16  .
	Add24L	TBLPTRL,ACCESS,TableAdr ;      
	endm

FXMTab1608U	macro	D_Arg,A1D,A_Arg,A1A;16     8   
 tblrd*+	;    
	movf	TABLAT,W,ACCESS	;   16  

;	mulwf	PCPWM_Amp,ACCESS;     
	mulwf	A_Arg,A1A;      V/F

	movff16	PRODL,D_Arg	; ,  
	clrf	D_Arg+2,A1D	;     
;	clrf	SynMulBuf+3,BANKED	;    0	
 tblrd*+	;    
;	movf	Syn16+1,W,BANKED;   16  
	movf	TABLAT,W,ACCESS	;   16  
;	movf	Syn16+1,BANKED	;   16     

;	mulwf	PCPWM_Amp,ACCESS;     
	mulwf	A_Arg,A1A;;      V/F
	
	MOVF	PRODL,W,ACCESS;	;  16  
	ADDWF	D_Arg+1,F,A1D;  8*8
	MOVF	PRODH,W,ACCESS	;   32 
	ADDWFC	D_Arg+2,F,A1D;   1 
;	CLRF	WREG,ACCESS;	; ADD16 Macro	;     
;	ADDWFC	SynMulBuf+3,F,BANKED			; 		 
	endm	

WaitTimeL	MACRO Literal8,TimeCounter,Adr0,TimeStamp,Adr1,ExitCode8	;    
;     . 
	movf	TimeStamp,W,Adr1		;  
	subwf	TimeCounter,W,Adr0		;   
	sublw	Literal8		;     
	btfsc	_C				;      -  
 		retlw	ExitCode8	;    -  ,   " ".
			ENDM				
Con16v12	MACRO Destin,AdrD,Source,AdrS	;  16  12 
;        
	 swapf	Source+0,W,AdrS	;      
	andlw	0x0F	;    
	movwf	Destin,AdrD	;    
	 swapf	Source+1,W,AdrS	;        
	andlw	0xF0	;    
	iorwf	Destin,F,AdrD	;      
	 swapf	Source+1,W,AdrS	;        
	andlw	0x0F	;    
	movwf	Destin+1,AdrD	;      .
			ENDM
RShift16_N	macro	A_Arg,A1A,NumShift
;    
 local a = 0
    while a < NumShift
	bcf	_C	;  1    
 rrcf A_Arg+1,F,A1A	;  
 rrcf A_Arg+0,F,A1A	;  
a += 1				;   
    endw
 endm
LShift24_N	macro	A_Arg,A1A,NumShift
;    
 local a = 0
    while a < NumShift
	bcf	_C	;  1    
 rlcf A_Arg+0,F,A1A	;  
 rlcf A_Arg+1,F,A1A	;  
 rlcf A_Arg+2,F,A1A	;   
a += 1
    endw
 endm
				
