	;extern	KeyBuf
Write_LCD
	LCD_BANK
; global		Write_LCD		;    WREG  LCD.
;;  LCD_RS   .
;;   - LCD_Key_Port  .
;
; global		Read_LCD_BF		;   
;;     LCD ,   - 
;; !!!!     !!!! (    ),
;;  -  .   WREG.
;     (      )
;       -  -   
;
; global		Read_LCD		;    LCD  WREG.
;;  LCD_RS   .
;;   - LCD_Key_Port  .

;  LCD_RS   .    WREG  LCD.
;   -   .   .

	bcf		LCD_RW			;  __ 
 .if Short_Lcd_Bus == 1 ;     -    ...
;     -     LCD  
;      .
 		#ifdef Nibble_Lcd_Bus ;    
;    -  ,  .
	movwf	Write_LCD_W_Buf+0,BANKED;ACCESS			;   
	movwf	Write_LCD_W_Buf+1,BANKED;ACCESS			;   
	swapf	Write_LCD_W_Buf+0,F,BANKED;ACCESS		;    
;1.        -0    
	movlw	0xF0	;LCD_Key_Mask10	;  =1 =0
	andwf	LCD_Key_TRIS,F,ACCESS	;      ()

	iorwf	Write_LCD_W_Buf+0,F,BANKED	;      
	iorwf	Write_LCD_W_Buf+1,F,BANKED	; (  ) 

	movf	LCD_Key_Lat,W,ACCESS	;     
	iorlw	0x0F	;LCD_Key_Mask01		;    -     
	andwf	Write_LCD_W_Buf+0,W,BANKED	;      
	movwf	LCD_Key_Lat,ACCESS	;      
		#else
;   
	bcf		LCD_Key_TRIS3	; 
	bcf		LCD_Key_TRIS2	; 
	bcf		LCD_Key_TRIS1	; 
	bcf		LCD_Key_TRIS0	; 

	movb	WREG,7,ACCESS,LCD_Key_Lat3
	movb	WREG,6,ACCESS,LCD_Key_Lat2
	movb	WREG,5,ACCESS,LCD_Key_Lat1
	movb	WREG,4,ACCESS,LCD_Key_Lat0
 		#endif

; rcall	Delay; -  10/03/2017, 12 , .
	bsf		LCD_E				;  
		rcall	Delay	;   
	bcf		LCD_E				;  
		rcall	Delay	;   
 		#ifdef Nibble_Lcd_Bus ;    
;   
	iorlw	0x0F	;LCD_Key_Mask01		;    -     
	andwf	Write_LCD_W_Buf+1,W,BANKED;
	movwf	LCD_Key_Lat,ACCESS	;
		#else
	movb	WREG,3,ACCESS,LCD_Key_Lat3 ; 
	movb	WREG,2,ACCESS,LCD_Key_Lat2 ; 
	movb	WREG,1,ACCESS,LCD_Key_Lat1 ; 
	movb	WREG,0,ACCESS,LCD_Key_Lat0 ;  
 		#endif
; rcall	Delay; -  10/03/2017, 12 , .
	bsf		LCD_E				;  
; rcall	Delay; -  10/03/2017, 12 , .
	bcf		LCD_E				;  
; rcall	Delay; -  10/03/2017, 12 , .

 		#ifdef Nibble_Lcd_Bus ;    
	movlw	LCD_Key_Mask01	;
	iorwf	LCD_Key_TRIS,F,ACCESS	;       
		#else
	bsf		LCD_Key_TRIS3	; 
	bsf		LCD_Key_TRIS2	; 
	bsf		LCD_Key_TRIS1	; 
	bsf		LCD_Key_TRIS0	; 
		#endif


;       
;				movff	LCD_Key_Port,KeyBuf	;   ""  
;
;	movb	LCD_Key_Port3,KeyBuf,3,0 ; 
;	movb	LCD_Key_Port2,KeyBuf,2,0 ; 
;	movb	LCD_Key_Port1,KeyBuf,1,0 ; 
;	movb	LCD_Key_Port0,KeyBuf,0,0 ;   
;

 .else	;    - 8  -  ...
		rcall	Delay	;   
	clrf	LCD_Key_TRIS,ACCESS		;   -   .
	movwf	LCD_Key_Lat,ACCESS		;   .
		rcall	Delay	;   
	bsf		LCD_E				;
;    -         ...
;   - .
       ;rcall	Delay	;   ; btfss	LCD_RS,0	;       
; rcall	Wait_Debug_Key			;    -  
 nop
	bcf		LCD_E				;
	setf	LCD_Key_TRIS,ACCESS	;   -   .
 .endif

	return

Read_LCD_BF	;     LCD ,   - 
		; !!!!     !!!! (  ),
		;  -  .
		; 8    WREG.
		;  4      -  WREG

	btfsc		TaskFlag1,2,ACCESS		;    100     -1 
	;nop
		rcall	KeyboardRead	;         

	bcf		LCD_RS				;    44780
 .if Short_Lcd_Bus == 1 ;    
;     -     LCD  
;      .
;        

 		#ifdef Nibble_Lcd_Bus ;  
	movlw	LCD_Key_Mask01	;
	iorwf	LCD_Key_TRIS,F,ACCESS	;       
		#else
	bsf		LCD_Key_TRIS3	; 
	bsf		LCD_Key_TRIS2	; 
	bsf		LCD_Key_TRIS1	; 
	bsf		LCD_Key_TRIS0	; 
		#endif
;
	bsf		LCD_RW			; 1=
	bsf		LCD_E			; 1= 	
;rcall	Wait_Debug_Key		;
		rcall	Delay	;   
	btfss	LCD_Key_Port3	;    
		bra	BF_Clear					
											; - 
	bcf		_C	; STATUS   infsnz	; 8  	 
	infsnz	LCD_BF_TimeOut+0,F,BANKED		; 16   -
		incf	LCD_BF_TimeOut+1,F,BANKED	;     .
	btfsc	_C	;   incf		;    ?
;		nop									;    ?
 clrf LCD_Flg,ACCESS;    -  

 .if Debug_LCD_Busy == 1 
	nop ; -      -   .
 .else
	pop		;   -     
 .endif
	bra		BF_Done

BF_Clear
	clrf	LCD_BF_TimeOut+0,BANKED	;
	clrf	LCD_BF_TimeOut+1,BANKED	;
BF_Done
		
;	movb	WREG,7,0,LCD_Key_Port,7,0 
;	movf	LCD_Key_Port,W,0	;  
;		rcall	Delay	;   
	bcf		LCD_E				;
		rcall	Delay	;   
	bsf		LCD_E				; 1=  
		rcall	Delay	;   
	bcf		LCD_E				;
	bcf		LCD_RW			;   
;	bsf		LCD_RS			;    44780
 .else	;  
	rcall	Read_LCD				;  +BF
	btfsc	WREG,7,0				;   BF
;	bra		Busy_Clear		
 .if Debug_LCD_Busy == 1 
	nop ; -      -   .
 .else
	pop		;   -     
 .endif
	;      (    )
; bsf		Debug_LED,0	;  
	return							;  -   
; ,  -   .
;Busy_Clear
 ;bcf		Debug_LED,0	;  
 .endif
	return

;;Read_LCD
;;  LCD_RS   .    LCD  WREG.
;;   -   .   .
;; rcall	Wait_Debug_Key		;
;; clrf	LCD_Key_Port,0		;
; .if Short_Lcd_Bus == 1 ;     -    ...
;;     -     LCD  
;;      .
;;        .
; .else
;	setf	LCD_Key_TRIS,0		;   -   .
;	bsf		LCD_RW			; 1=
;		rcall	Delay	;   
;	bsf		LCD_E				; 1= 	
;;rcall	Wait_Debug_Key		;
;		rcall	Delay	;   
;	movf	LCD_Key_Port,W,0	;  
;		rcall	Delay	;   
;	bcf		LCD_E				;
;		rcall	Delay	;   
;
;	bcf		LCD_RW			;     
; .endif
;	return
;
 global LCD_Delay
LCD_Delay
Delay
 #if Debug_LCD_Busy == 1 
;	nop ; -      -   .
 #else
		nop							;  
		nop							; 
		nop							;  
		nop							; 
		nop							;  
		nop							; 
;		nop							;  
;		nop							; 
;		nop							;  
;		nop							; 
;		nop							;  
;		nop							; 
;		nop							;  
;		nop							; 
;		nop							;  
;		nop							; 
;		nop							;  
;		nop							; 
 #endif
	return

;******************************************************************************
;End of program
