; DeBug 12 bit
;   Help   USART 
;   bcf    TRISC,6      ; Make RC6 an output
;   movlw  19h          ; 9600 baud @4MHz
   movlw  0x01          ; / baud @ 48 MHz  
   movwf  SPBRG,ACCESS	; 	

   bsf    TXSTA,TXEN,ACCESS   ; Enable transmit
   bsf    TXSTA,BRGH,ACCESS   ; Select high baud rate
	bsf    BAUDCTL,BRG16,ACCESS; Select 16    baud rate
;  400-500    50 
   
   bsf    RCSTA,SPEN,ACCESS   ; Enable Serial Port
   bsf    RCSTA,CREN,ACCESS   ; Enable continuous reception

;	Extern	Table_Sinus
		PCPWM_Page	; BSR for PCPWM Task
	movlf	0x3A,DeBug_BufLcd+9,BANKED;    9    .
	movlf	0x0,PCPWM_MK1+0,BANKED; .     12 	 
	movlf	0x14,PCPWM_MK1+1,BANKED; .     12 	 


	clrf	PCPWM_AmpSin+0,BANKED	;      V/F  
	clrf	PCPWM_AmpSin+1,BANKED	; 
	
	bra		DeBugLoopAmp
;   0x0D   0x0A    -   
;   .
HexNibSend
	andlw	0x0F					;    
	addlw	0x30					;
	cpfsgt	DeBug_BufLcd+9,BANKED;   9 > WREG	
	addlw	0x7				;     
ByteSend
	movwf	TXREG,ACCESS			;
	nop	;     USART
;	btfss	PIR1,TXIF,ACCESS	;    USART
	btfss	TXSTA,TRMT,ACCESS	;    
	bra		$-2					;
		return
SendHexWord	macro	ArgA,Adr1,Lit1
; 23/01/2020      -   .
	movlw	Lit1	;     
	rcall	ByteSend	; 

	swapf	ArgA+1,W,Adr1	;   - 
	rcall	HexNibSend	;   

	movf	ArgA+1,W,Adr1	;
	rcall	HexNibSend	;   

	swapf	ArgA+0,W,Adr1	;
	rcall	HexNibSend	;  

	movf	ArgA+0,W,Adr1	;
	rcall	HexNibSend	;  

 endm

DeBugLoopAmp:

	EXTERN	PDC_TableLoad	;
 call	PDC_TableLoad		;


	clrf	DeBug_BufLcd+0,BANKED	;  
	clrf	DeBug_BufLcd+1,BANKED	; 16   

;	movlw	0x0D	;     
;	rcall	ByteSend	; 
	movlw	0x0A	;     
	rcall	ByteSend	; 

 SendHexWord	PCPWM_AmpSin+0,BANKED,"%"	; =====0====== PCPWM_AmpSin+0,BANKED	;      V/F  

DeBugLoop:

	movlw	";";0x0D	;     
	rcall	ByteSend	; 
	movlw	0x0A	;     
	rcall	ByteSend	; 

; ============      =============
PDC_16L	equ	PDC0L 	;
PDC_16H	equ	PDC0H 	; 
Angle_8	equ	DeBug_BufLcd+1 ; 
	BSF EECON1, EEPGD,ACCESS	; Point to PROGRAM memory

NotSendSinus	;   2  

;	Inc16	DeBug_BufLcd+0,BANKED	;   
	Add16L	DeBug_BufLcd+0,BANKED,0x20	;      16  		
;	movf	DeBug_BufLcd+1,W,BANKED	; 12   
;	andlw	0xF0					;    
;		bz	$+6		;  GoTo
		bnc	$+6		;  GoTo
	goto EndDeBugLoop			; 

;	movf	DeBug_BufLcd+1,W,BANKED	; 12   
;	andlw	0x0F					;    
;	movwf	DeBug_BufLcd+1,BANKED	;   
;	movwf	TBLPTRH,ACCESS			;  
;	movff	DeBug_BufLcd+0,TBLPTRL	;
;
;	btfss	TBLPTRL,0,ACCESS	;   -   
;		bra		NotSendSinus

; ===========      (     )

;;  12    16   - 9      .
	 swapf	Angle_8-1,W,BANKED	;      
	andlw	0x0F	;    
	movwf	TBLPTRL,ACCESS	;    
	 swapf	Angle_8+0,W,BANKED	;        
	andlw	0xF0	;    
	iorwf	TBLPTRL,F,ACCESS	;      
	 swapf	Angle_8+0,W,BANKED	;        
	andlw	0x0F	;    
	movwf	TBLPTRH,ACCESS	;      .
;---
; btfss TBLPTRL,0,ACCESS	;   -   
;  bra NotSendSinus		;   -    
;---
	bcf		TBLPTRL,0,ACCESS	;   -   

;****************************************************************************************
; SendHexWord DeBug_BufLcd+0,BANKED,"#";=====1======    
 SendHexWord TBLPTRL+0,ACCESS,"#";   	   
;****************************************************************************************

	btfsc	TBLPTRH,3,ACCESS	;	  12  
		bra	Reverse	; 

	Add16L	TBLPTRL,ACCESS,Table_Sinus	;     

;#ifdef	PCPWM_CoSinus; Yes	;  ~2        ~10 
		bra DoneAdress
Reverse	;      .
	bcf		TBLPTRH,3,ACCESS	;	  12  
	movf	TBLPTRL,W,ACCESS	;
	sublw	low(Table_Sinus+0x802)		;   
	movwf	TBLPTRL,ACCESS		;
	movf	TBLPTRH,W,ACCESS	;  
	btfss	_C		;     
	incfsz	WREG,W,ACCESS	;      1,
	sublw	high(Table_Sinus+0x802);   
	movwf	TBLPTRH,ACCESS		;
DoneAdress
; *****     



;1)   :
 tblrd*+	;       
	movf	TABLAT,W,ACCESS	;   16  
	movwf	SynMulBuf+7,BANKED;  -   

;****************************************************************************************
 movwf	DeBug_BufLcd+6,BANKED; ********  USART
;****************************************************************************************

 mulwf	PCPWM_AmpSin+0,BANKED;      V/F  
	movff16	PRODL,SynMulBuf+0	;  

 tblrd*+	;    
	movf	TABLAT,W,ACCESS	;   16  

;****************************************************************************************
  movwf	DeBug_BufLcd+7,BANKED; ********  USART
 SendHexWord	DeBug_BufLcd+6,BANKED,"=" ;=====2======    
  movf	TABLAT,W,ACCESS	; ******  *********   16  
;****************************************************************************************

;2)   :
 mulwf	PCPWM_AmpSin+1,BANKED;      <0x10
;	movff16	PRODL,SynMulBuf+2	;     
	movff	PRODL,SynMulBuf+2	;     

;  4    -    .

;3)  Sin   Amp,    
 mulwf	PCPWM_AmpSin+0,BANKED;      V/F  

; ArgB,A1B,ArgA,A1A	;   -  ;   B=B+A 
  Add16	SynMulBuf+1,BANKED,PRODL,ACCESS;    

		 
;4)  Sin   Amp,    
	movf	SynMulBuf+7,W,BANKED;  Sin 
 mulwf	PCPWM_AmpSin+1,BANKED;     

; ArgB,A1B,ArgA,A1A	;   -  ;   B=B+A 
  Add16	SynMulBuf+1,BANKED,PRODL,ACCESS;    


	btfss	TABLAT,7,ACCESS	;    16  
		bra	ExitMul
;Sub16 ArgB,A1B,ArgA,A1A ;   -  ;  B=B-A 
  Sub16	SynMulBuf+2,BANKED,PCPWM_AmpSin+0,BANKED;     FXM1616S


ExitMul
;          8 355 585/0x7f7f01  -8 355 585/0x8080FF

#ifdef __DEBUG;*******   
	movf	SynMulBuf+0,W,BANKED;     
	movf	SynMulBuf+1,W,BANKED;  0  
	movf	SynMulBuf+2,W,BANKED;  1  
	movf	SynMulBuf+3,W,BANKED;    = 0  
 #endif
 
;     -       
;       0  2048  PDC, ,  = 0 = 1024 PDC.
;0=0=0000=00000000==  
;64=90=7fff=007f7f01= ,   FEFE02,   - 7F7
;128=180=0000=00000000=  ,   FEFE02
;192=270=8001=ff8080ff= =  = 00000000000
;255=359=fcdc=fffcdf24= ,   = 7c5e25 -   
	movlw	0x01;	;  32     0x7f7f01
	ADDWF	SynMulBuf+0,F,BANKED; 
	movlw	0x7F;	;  32     0x7f7f01
	ADDWFC	SynMulBuf+1,F,BANKED; -1
	movlw	0x7F;	;  32     0x7f7f01
	ADDWFC	SynMulBuf+2,F,BANKED; -2

;****************************************************************************************
 SendHexWord	SynMulBuf+1,BANKED,"*" ; =====3======   *   
;****************************************************************************************

; 16   * 8   = 24 ,   ,   16 .
; 16          ,    .
;       0.
;  16     11-12   -    16 , 
;  32    11-12  
;    1/10     
	movlw	low(0xFFFF/0xA);,W	,A1A	;   10%  0xFFFF
	subwf	SynMulBuf+1,F,BANKED		;    ,  : =B-A

	movlw	high(0xFFFF/0xA);,W,A1A		;  , 10%  0xFFFF
;	btfss	_C		;     
;	incfsz	ArgA+1,W,A1A	;      1,
	subwfb	SynMulBuf+2,F,BANKED	;     -   
 #ifdef	PCPWM_Board; Yes	;    /  
		bnc	ZeroPoint	;  -       
 #else
		bnc	BotWithoutPWM;  -     
 #endif
;    1/5       
	movlw	low(0xFFFF-0xFFFF/0x5);,W	,A1A	;   10%  0xFFFF
	subwf	SynMulBuf+1,W,BANKED		;      

	movlw	high(0xFFFF-0xFFFF/0x5);,W,A1A		;  , 10%  0xFFFF
	subwfb	SynMulBuf+2,W,BANKED	;     -   
		bc	MaxPoint	;   -  

;****************************************************************************************
 SendHexWord	SynMulBuf+1,BANKED,"+" ; =====4======  /    *   
;****************************************************************************************

;     ,         11  
; PCPWM_MK1+0   \Init_PCPWM_3F.inc:217
 ;FXM1616U2 macro D_Arg,A1D,A_Arg,A1A,B_Arg,A1B,_Work,A1W; ;    -  
; FXM1616U2	SynMulBuf+4,	bnk,	SynMulBuf+1,	bnk,	PCPWM_MK1+0,	bnk,	SynMulBuf+0,	bnk;	  
; FXM1680U	SynMulBuf+4,	bnk,	SynMulBuf+1,	bnk,	PCPWM_MK1+0,	bnk;,	SynMulBuf+0,	bnk;	  
  FXM1680U2	SynMulBuf+4,	bnk,	SynMulBuf+1,	bnk,	PCPWM_MK1+0,	bnk;,	SynMulBuf+0,	bnk;	  
	movff	PRODL,PDC_16L	;  
	movff	PRODH,PDC_16L-1	;  
;	movff	SynMulBuf+6,PDC_16L		;  
;	movff	SynMulBuf+7,PDC_16L-1	;  

;****************************************************************************************
 movff	PRODL,DeBug_BufLcd+4 ;  
 movff	PRODH,DeBug_BufLcd+5 ;  
;****************************************************************************************

		bra		Done

MaxPoint:
; 05/01/2019      
;    PDC=4*PTPer-DTCon -    DT -  
;      ~ 0.1 .
;PcPwmPdcMax	:2;F,BANKED;  PDC   -  

; movf	DTCON,W,ACCESS	;  #1 - Dead Time Unit
 movf	PcPwmTopDT,W,BANKED;  #2 =        
 		bz	TopWithoutCharge	;    -   
 movff	PcPwmPdcMax+1,SynMulBuf+0	;     
 subwf	PcPwmPdcMax+0,W,BANKED	; ,   
 btfss	_C	;  
 	decf	SynMulBuf+0,F,BANKED	;  
 bsf	_C	;   
 subfwb	DTCON,W,ACCESS	;  #1 - Dead Time Unit
			;    
 btfss	_C	;  
 	decf	SynMulBuf+0,F,BANKED	;  

 movwf	PDC_16L,ACCESS			; .  
 movff	SynMulBuf+0,PDC_16L-1;,ACCESS		; .  

;****************************************************************************************
 movwf DeBug_BufLcd+4,BANKED; .    
 movff SynMulBuf+0,DeBug_BufLcd+5;,BANKED; .    
;****************************************************************************************
		bra		Done

TopWithoutCharge
	movff	PcPwmPdcMax+0,PDC_16L;,ACCESS; .  
	movff	PcPwmPdcMax+1,PDC_16L-1;,ACCESS; .  

;****************************************************************************************
 movff PcPwmPdcMax+0,DeBug_BufLcd+4;,BANKED; .    
 movff PcPwmPdcMax+1,DeBug_BufLcd+5;,BANKED; .    
;****************************************************************************************

		bra		Done
ZeroPoint:	;   =0,      
;     PDC -    DTCON -    
;    DT.
;    PDC=DTCon -    DT -  
;      ~ 0.1 .
; *****       DT - ***  ***  .*****
;    -         DT.
;
 clrf	SynMulBuf+0,BANKED	;     
 movf	PcPwmTopDT,W,BANKED;  #1 =        
 		bz	BotWithoutPWM	;    -   
 addwf	DTCON,W,ACCESS	;  2
 btfsc	_C	;
 	incf	SynMulBuf+0,F,BANKED	;     

 movwf	PDC_16L,ACCESS	;  
 movff	SynMulBuf+0,PDC_16L-1;,ACCESS; . 

;****************************************************************************************
 movwf DeBug_BufLcd+4,BANKED; . ZeroPoint  
 movff SynMulBuf+0,DeBug_BufLcd+5;,BANKED; . ZeroPoint  
;****************************************************************************************


; movlf	0x19,PDC_16L,ACCESS	;  
		bra		Done
BotWithoutPWM
	clrf	PDC_16L,ACCESS	;  
	clrf	PDC_16L-1,ACCESS	;;  

;****************************************************************************************
	clrf	DeBug_BufLcd+4,BANKED	;  
	clrf	DeBug_BufLcd+5,BANKED	;  
;****************************************************************************************

Done:

;****************************************************************************************
; 23/01/2020          -   
; movff	PDC_16L,DeBug_BufLcd+4		;  
; movff	PDC_16L-1,DeBug_BufLcd+5	;  
 SendHexWord	DeBug_BufLcd+4,BANKED,"$";=====5======   PDC
;****************************************************************************************

						goto	DeBugLoop	
; 	SinTabLdDbg	 Angle_1+2,PDC0L	;      

EndDeBugLoop

;	Inc16	PCPWM_AmpSin+0,BANKED	; ;    
	Add16L	PCPWM_AmpSin+0,BANKED,0xD ;    

	movf	PCPWM_AmpSin+1,W,BANKED	;  
	andlw	0xF0					;    
		bnz	$+6
 	goto	DeBugLoopAmp	

	nop
	nop
	halt
	sleep
	bra $-2
