; ********** GENERATED Common Main Loop Task File Created 01/07/2020 11:47:07.29 
; *******************  Begin File Main\MLTask_Main.inc ***************** 

;	*** main code goes here ***
;	movf	TMR1L,W,ACCESS	;	clrwdt

; #endif
 ; *******************  Begin File EPROM\MLTask_EPROM.inc ***************** 
;*********************   	  *******************************

 extern	EPROM_Sync
;	EPROM_Page; BSR for EPROM Task  EePROM_Sync
 #ifdef	LCD_Present
	btfsc	LCD_Flg1,0,ACCESS	;    ?
		call	EPROM_Sync	;  -     
 #endif
; *******************  Begin File Beeper\MLTask_Beeper.inc ***************** 
;		Beeper_Page	;
;	movlw	0x20
	
	;	dcfsnz	DeBug_Beeper,F,BANKED
	;	Beeper_Toggle	;
; *******************  Begin File LCD_Key_Enc\MLTask_LCD_Key_Enc.inc ***************** 
	extern	LCD_Task,Task_Keys,Task_KeyBoardInput,Encoder

;********************** LCD 44780  , ,   *******************
 ;LCD_BANK	;    	
 ;DefaultBankSelect
	;movlb	0x0					; BSR  1  LCD_Task
	btfss	LCD_Flg,4,ACCESS	;  LCD    ?
		call	LCD_Task	;  -    .
;************ Encoder Task **********************
 ;LCD_BANK	;    
	;DefaultBankSelect
	;movlb	0x0					; BSR  1  StepTask
	btfsc	TaskFlag1,1,ACCESS		;  PortB    PortB ?
		call	Task_Keys		;	  
 ;************           **********************
 ;LCD_BANK	;    
	;DefaultBankSelect
	;movlb	0x0					; BSR  1  StepTask
	btfsc	TaskFlag1,2,ACCESS		;  KeyRead    100  ?
		call	Task_KeyBoardInput		;	  

	btfsc	TaskFlag1,3,ACCESS		;  Encoder      ?
		call	Encoder		;	  

; *******************  Begin File 1W\MLTask_1W.inc ***************** 
;************* 1-Wire  *********************
  extern	W1_Task	;   	
;	W1_Page	; movlb	0x0					; BSR  0 
	btfsc	W_1_Flg,0,ACCESS		;  1-Wire   ?
		call	W1_Task		;	      
;	bra		DoneW1_Task		;   -    
; *******************  Begin File PCPWM_3F\MLTask_PCPWM_3F.inc ***************** 
;************ PCPWM_Task **********************
 	;	PCPWM_Page	;
 Extern	StopMotor	;
;      12 
;	btfsc	PCPWM_Flag,0,ACCESS	;  PCPWM  ?
;		call	PCPWM_Task ;   .
;      18750 
	btfss	PCPWM_Flag,1,ACCESS	; 1/100   ?
		bra	DoneSpeedCalc
	PCPWM_Page	; BSR for PCPWM Task
	bcf	PCPWM_Flag,1,ACCESS	;  ,    
 Extern	SpeedCalc			;
		call	SpeedCalc ;   .
	;	dcfsnz	DeBug_Beeper,F,BANKED
	;	Beeper_Toggle	;
DoneSpeedCalc

;      9 375/XX 
	btfss	PCPWM_Flag,5,ACCESS	; 1/XX   ?
		bra	DoneSpeedChange

		PCPWM_Page	; BSR for PCPWM Task
	bcf PCPWM_Flag,5,ACCESS	;;5=     9 375  ,   
 	movff	PCPWM_Accelerate,PCPWM_AccelCounter;     
	movf	PcPwmProg,W,BANKED	;,F,BANKED;10=   
	 bnz		PcPwmProg_1 ;  
; =========   0 ===============
 Extern	SpeedChange		;
	call	SpeedChange ;  0 =  = 0 =      .
     bra	SaveMotorStatus

; =========   1 ===============
PcPwmProg_1
	decfsz	WREG,W,ACCESS
		bra		PcPwmProg_2
 Extern	SpeedChange1	 ;
	call	SpeedChange1 ; 1 =  = 1 .
	bra	SaveMotorStatus

; =========   2 ===============
PcPwmProg_2
	decfsz	WREG,W,ACCESS
		bra		PcPwmProg_3
 Extern	SpeedChange2	 ;
	call	SpeedChange2 ; 2 =  = 2 .
	bra	SaveMotorStatus

; =========   >2 ===============
PcPwmProg_3
 Extern	SpeedChange3
	call	SpeedChange3 ; >2  = 3 .
SaveMotorStatus
	movwf	PCPWM_MotorStatus,BANKED ;
;	bra	DoneSpeedChange
;
DoneSpeedChange
	btfss	PCPWM_Flag,7,ACCESS	;   ?
		bra	DoneRevCalc
	
	PCPWM_Page	; BSR for PCPWM Task
 Extern	RevCalc ; DelayCuriosity,  
		call	RevCalc ;   .

DoneRevCalc
	;	dcfsnz	DeBug_Beeper,F,BANKED
	;	Beeper_Toggle	;
; call	DelayCuriosity	;	   
 ; *******************  Begin File RTK\MLTask_RTK.inc ***************** 
 extern	TK_10,TK_100,TK_1000;    

;		ADC_Page	; BSR for ADC Task
;	Inc24	ADC_Cnt_All,BANKED	;  

;************ Time keeping **********************
;         - 
;    1000,100  10     
;   -    
;     100  1000  (18750       100  1000)
;  10      -    (   ).
	btfss	TaskFlag1,6,ACCESS		;  1000      ?
		bra	DoneTK_1000
	bcf	TaskFlag1,6,ACCESS		;  1000   
		RTK_Page	;
	call	TK_1000		;	   1000 
;	movwf	StatusRTK_1000
DoneTK_1000

	btfss	TaskFlag1,5,ACCESS		;  100      ?
		bra	DoneTK_100
	bcf	TaskFlag1,5,ACCESS		;  100  
		RTK_Page	;
	call	TK_100		;	   100 
;	movwf	StatusRTK_100
DoneTK_100

	btfss	TaskFlag1,0,ACCESS		;  10      ?
		bra	DoneTK_10
		RTK_Page	;
	bcf	TaskFlag1,0,ACCESS		;  10      ?
	call	TK_10		;	   10 
;	movwf	StatusRTK_10
DoneTK_10
; *******************  Begin File ADC\MLTask_ADC.inc ***************** 
 extern ADC_Task				;
	btfsc	ADC_Flag,0,ACCESS	;
		call	ADC_Task		;
; *******************  Begin File Math\MLTask_Math.inc ***************** 
;TestLoop
;*********************  ,      RTOS *******************************
 extern Math_Task
	btfss	Math_Flag,0,ACCESS	;    ?
		bra	DoneMath
	Math_Page; BSR for Math Task 
 call	Math_Task	;  -    
;	movwf	Math_Status,BANKED ;   
DoneMath